using System;
using System.IO;
using System.Collections;
using System.Xml;
using System.Xml.Serialization;

namespace PSP
{
	/// <summary>
	/// ۑF04A_CS
	///     `ǍW0A1߂B
	/// 쐬Ftsutomu
	/// PSPStudy o[WF1.03
	/// </summary>
	class C04A_CS
	{
#if C04A_CS
		/// <summary>
		/// 0̏ꍇASeXgsAʂ result.txt ɏo͂܂B
		/// 1ȏ̏ꍇAt@Cf[^ǂŌʂWo͂ɏo͂܂B
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			if (args.Length == 0)	// Sf[^ŃeXg
			{
				Directory.SetCurrentDirectory("../..");
				CAllTest.Check("tsutomu","04A_CS",new Delegate(Main),false);
				return;
			}
			CLinkList	l = new CLinkList();
			if (!ReadData(args[0],l)) return;
			double[]	ans = new double[5];
			Calc(l,ans);
			Console.WriteLine("{0:F5} {1:F5}",ans[3],ans[4]);
		}
#endif
		/// <summary>
		/// t@Cf[^Ǎ݂܂B
		/// </summary>
		public static bool ReadData(string fnam,CLinkList l)
		{
			// t@CJ
			try 
			{
				XmlSerializer xr = new XmlSerializer(typeof(double[][]));
				StreamReader sr = new StreamReader(fnam);
				double[][] data = (double[][])xr.Deserialize(sr);
				sr.Close();
				foreach (double[] d in data) l.Add(d);
			}
			catch (FileNotFoundException e) 
			{
				Console.Error.WriteLine(e.Message);
				return false;
			}
			return true;
		}
		/// <summary>
		/// 0A1vZ܂B
		/// </summary>
		public static void Calc(CLinkList l,double[] ans)
		{
			double	sumx,sumy,sumxx,sumxy,b0,b1;
			sumx = sumy = sumxx = sumxy = 0;
			foreach (double[] d in l) 
			{
				sumx += d[0];
				sumy += d[1];
				sumxx += d[0]*d[0];
				sumxy += d[0]*d[1];
			}
			if (l.Count > 0) sumx /= l.Count;
			if (l.Count > 0) sumy /= l.Count;
			b1 = sumxx - l.Count * sumx * sumx;
			if (b1 != 0) b1 = (sumxy - l.Count * sumx * sumy) / b1;
			b0 = sumy - b1 * sumx;
			ans[1] = sumx;
			ans[2] = sumy;
			ans[3] = b0;
			ans[4] = b1;
		}
	}
	/// <summary>
	/// NXg
	/// </summary>
	public class CLinkList
	{
		private class Enumrt : IEnumerator 
		{
			private Data		cur;
			private Data		top;
			public Enumrt(Data d) {top = d; Reset();}
			public void Reset() {cur = top;}
			public object Current 
			{
				get {return cur.dat;}
			}
			public bool MoveNext()				
			{
				if (cur.next == null) return false;
				cur = cur.next;
				return true;
			}
		}
		private class Data 
		{
			public object	dat;
			public Data		next;
			public Data(object o) {dat = o; next = null;}
		}
		private int			n;
		private Data		dt;
		public CLinkList()
		{
			n = 0;
			dt = new Data(null);
		}
		public int Count 
		{
			get {return n;}
		}
		public void Add(object o) 
		{
			Data	p = dt;
			while (p.next != null) p = p.next;
			p.next = new Data(o);
			++n;
		}
		public IEnumerator GetEnumerator()
		{
			return new Enumrt(dt);
		}
	}
}
