Imports System.IO
Imports System.Xml
Imports System.Xml.Serialization

Namespace PSP
    ''' ۑF04A_VB
    '''     `Aɂ\
    ''' 쐬Ftsutomu
    ''' PSPStudy o[WF1.03
    Public Class C04A_VB
#If C04A_VB Then
        Shared Sub Main(ByVal args() As String)
            If (args.Length = 0) Then ' Sf[^ŃeXg
                Directory.SetCurrentDirectory("..")
                AllTest.Check("tsutomu", "04A_VB", AddressOf Main, False)
                Exit Sub
            End If
            Dim l As LinkList = New LinkList()
            If (Not ReadData(args(0), l)) Then Return
            Dim sumx, sumy, b0, b1 As Double
            Calc(l, sumx, sumy, b0, b1)
            Console.WriteLine("{0:F5} {1:F5}", b0, b1)
        End Sub
#End If
        ''' t@Cf[^Ǎ݂܂B
        Public Shared Function ReadData(ByVal fnam As String, ByVal l As LinkList)
            Dim data()() As Double
            Try ' t@CJ
                Dim xr As XmlSerializer = New XmlSerializer(GetType(Double()()))
                Dim sr As StreamReader = New StreamReader(fnam)
                data = CType(xr.Deserialize(sr), Double()())
                sr.Close()
            Catch e As FileNotFoundException
                Console.Error.WriteLine(e.Message)
                Return False
            End Try
            Dim d() As Double
            For Each d In data
                l.Add(d)
            Next
            Return True
        End Function
        ''' 0A1vZ܂B
        Public Shared Sub Calc(ByVal l As LinkList, ByRef sumx As Double, ByRef sumy As Double, _
                ByRef b0 As Double, ByRef b1 As Double)
            Dim sumxx, sumxy As Double
            Dim d() As Double
            For Each d In l
                sumx += d(0)
                sumy += d(1)
                sumxx += d(0) * d(0)
                sumxy += d(0) * d(1)
            Next
            If (l.Count > 0) Then sumx /= l.Count
            If (l.Count > 0) Then sumy /= l.Count
            b1 = sumxx - l.Count * sumx * sumx
            If (b1 <> 0) Then b1 = (sumxy - l.Count * sumx * sumy) / b1
            b0 = sumy - b1 * sumx
        End Sub
    End Class
    ''' NXg
    Public Class LinkList
        Private Class Enumrt
            Implements IEnumerator
            Private cur As Data
            Private top As Data
            Public Sub New(ByVal d As Data)
                top = d
                Reset()
            End Sub
            Public Sub Reset() Implements IEnumerator.Reset
                cur = top
            End Sub
            Public ReadOnly Property Current() As Object Implements IEnumerator.Current
                Get
                    Return cur.dat
                End Get
            End Property
            Public Function MoveNext() As Boolean Implements IEnumerator.MoveNext
                If (cur.nxt Is Nothing) Then Return False
                cur = cur.nxt
                Return True
            End Function
        End Class
        Private Class Data
            Public dat As Object
            Public nxt As Data
            Public Sub New(ByVal o As Object)
                dat = o
                nxt = Nothing
            End Sub
        End Class
        Private n As Integer
        Private dt As Data
        Public Sub New()
            n = 0
            dt = New Data(Nothing)
        End Sub
        Public ReadOnly Property Count() As Integer
            Get
                Return n
            End Get
        End Property
        Public Sub Add(ByVal o As Object)
            Dim p As Data = dt
            While (Not p.nxt Is Nothing)
                p = p.nxt
            End While
            p.nxt = New Data(o)
            n += 1
        End Sub
        Public Function GetEnumerator() As IEnumerator
            Return New Enumrt(dt)
        End Function
    End Class
End Namespace

