using System;
using System.IO;
using System.Collections;
using System.Xml;
using System.Xml.Serialization;

namespace PSP
{
	/// <summary>
	/// ۑF01A_CS
	///     ςƕW΍o
	/// 쐬Ftsutomu
	/// PSPStudy o[WF1.03
	/// </summary>
	class C01A_CS
	{
#if C01A_CS
		/// <summary>
		/// 0̏ꍇASeXgsAʂ result.txt ɏo͂܂B
		/// 1ȏ̏ꍇAt@Cf[^ǂŌʂWo͂ɏo͂܂B
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			if (args.Length == 0)	// Sf[^ŃeXg
			{
				Directory.SetCurrentDirectory("../..");
				CAllTest.Check("tsutomu","01A_CS",new Delegate(Main),false);
				return;
			}
			CLinkList	l = new CLinkList();
			if (!ReadData(args[0],l)) return;
			double[]	ans = new double[2];
			Calc(l,ans);
			Console.WriteLine("{0:F2} {1:F5}",ans[0],ans[1]);
		}
#endif
		/// <summary>
		/// t@Cf[^Ǎ݂܂B
		/// </summary>
		public static bool ReadData(string fnam,CLinkList l)
		{
			// t@CJ
			try 
			{
				XmlSerializer xr = new XmlSerializer(typeof(double[]));
				StreamReader sr = new StreamReader(fnam);
				double[] data = (double[])xr.Deserialize(sr);
				sr.Close();
				foreach (double d in data) l.Add(d);
			}
			catch (FileNotFoundException e) 
			{
				Console.Error.WriteLine(e.Message);
				return false;
			}
			return true;
		}
		/// <summary>
		/// ςƕW΍vZ܂B
		/// </summary>
		public static void Calc(CLinkList l,double[] ans)
		{
			ans[0] = ans[1] = 0;
			foreach (double d in l) 
			{
				ans[0] += d;
				ans[1] += d*d;
			}
			ans[0] /= l.Count;
			ans[1] = Math.Sqrt((ans[1] - ans[0] * ans[0] * l.Count) / Math.Max(1,l.Count-1));
		}
	}
	/// <summary>
	/// NXg
	/// </summary>
	public class CLinkList
	{
		private class Enumrt : IEnumerator 
		{
			private Data		cur;
			private Data		top;
			public Enumrt(Data d) {top = d; Reset();}
			public void Reset() {cur = top;}
			public object Current 
			{
				get {return cur.dat;}
			}
			public bool MoveNext()				
			{
				if (cur.next == null) return false;
				cur = cur.next;
				return true;
			}
		}
		private class Data 
		{
			public object	dat;
			public Data		next;
			public Data(object o) {dat = o; next = null;}
		}
		private int			n;
		private Data		dt;
		public CLinkList()
		{
			n = 0;
			dt = new Data(null);
		}
		public int Count 
		{
			get {return n;}
		}
		public void Add(object o) 
		{
			Data	p = dt;
			while (p.next != null) p = p.next;
			p.next = new Data(o);
			++n;
		}
		public IEnumerator GetEnumerator()
		{
			return new Enumrt(dt);
		}
	}
}

