using System;
using System.IO;
using System.Collections;

namespace PSP
{
	/// <summary>
	/// ۑF03A_CS
	///     NXʂ ֐̐LOCóB
	/// 쐬Ftsutomu
	/// PSPStudy o[WF1.03
	/// </summary>
	class C03A_CS
	{
#if C03A_CS
		/// <summary>
		/// 0̏ꍇASeXgsAʂ result.txt ɏo͂܂B
		/// 1ȏ̏ꍇAt@Cf[^ǂŌʂWo͂ɏo͂܂B
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			if (args.Length == 0)	// Sf[^ŃeXg
			{
				Directory.SetCurrentDirectory("../..");
				CAllTest.Check("tsutomu","03A_CS",new Delegate(Main),false);
				return;
			}
			WriteLoc(args[0]);
		}
#endif
		/// <summary>
		/// t@CǂLOCo͂܂B
		/// </summary>
		public static void WriteLoc(string fnam)
		{
			// t@CJ
			StreamReader sr;
			try 
			{
				sr = new StreamReader(fnam);
			}
			catch (FileNotFoundException e) 
			{
				Console.WriteLine(e.Message);
				return;
			}
			ArrayList	all = new ArrayList();
			int			c,cc;
			bool		bIn = false;
			while ((c = sr.Read()) >= 0) 
			{
				if (c == '\\') 
				{
					sr.Read();
				}
				else if (c == '\'' || c == '"') 
				{
					while ((cc = sr.Read()) >= 0)
						if (cc == '\\') sr.Read();
						else if (cc == c) break;
				} 
				else if (c == ';' || c == '{' || c == '}') 
				{
					all.Add(((char)c).ToString());
				}
				if (Char.IsLetter((char)c) || c == '_')
				{
					string	id = ((char)c).ToString();
					while ((c = sr.Peek()) == '_' || Char.IsLetterOrDigit((char)c)) 
					{
						sr.Read();
						id += (char)c;
					}
					if (bIn) 
					{
						all.Add(id);
						bIn = false;
					} 
					else bIn = id == "class" || id == "struct" || id == "namespace";
				}
				if (c != '/') continue;
				c = sr.Peek();
				if (c == '/') 
				{
					while ((c = sr.Read()) != '\n') ;
				} 
				else if (c == '*') 
				{
					do 
					{
					while ((c = sr.Read()) >= 0)
						if (c == '*') break;
					} while (c >= 0 && sr.Peek() != '/');
					sr.Read();
				}
			}
			sr.Close();
			int			level = 0;
			SortedList	sl = new SortedList();
			string		ns = "";
			bool		bInClass = false;
			foreach (string s in all) 
			{
				if (s == "}") 
				{
					if (level > 0) 
					{
						--level; 
					} 
					else 
					{
						int	k = ns.LastIndexOf('.');
						ns = k < 0 ? "" : ns.Substring(0,k);
					}
					continue;
				} 
				int[] v = (int[])sl[ns];
				if (v == null) sl[ns] = v = new int[2];
				if (s == ";") 
				{
					++v[1];
				} 
				else if (s == "{") 
				{
					++v[1];
					if (bInClass) 
					{
						bInClass = false;
					}
					else
					{
						if (++level == 1) ++v[0];
					}
				}			
				else				
				{
					bInClass = true;
					if (ns != "") ns += ".";
					ns += s;
				}
			}
			int		t1 = 0, t2 = 0;
			Console.WriteLine("{0,-16} {1,4} {2,4}","Namespace","Func","LOC");
			foreach (DictionaryEntry de in sl) 
			{
				int[] dt = (int[])de.Value;
				if (de.Key.ToString() == "") continue;
				Console.WriteLine(" {0,-15} {1,4} {2,4}",de.Key.ToString(),dt[0],dt[1]);
				t1 += dt[0];
				t2 += dt[1];
			}
			Console.WriteLine("{0,-16} {1,4} {2,4}","Total",t1,t2);
		}
	}
}
