Imports System.IO
Imports System.Xml
Imports System.Xml.Serialization

Namespace PSP
    ''' ۑF06A_VB
    '''     90%70%̗\
    ''' 쐬Ftsutomu
    ''' PSPStudy o[WF1.03
    Public Class C06A_VB
#If C06A_VB Then
        ''' 0̏ꍇASeXgsAʂ result.txt ɏo͂܂B
        ''' 1ȏ̏ꍇAt@Cf[^ǂŌʂWo͂ɏo͂܂B
        Shared Sub Main(ByVal args() As String)
            If (args.Length = 0) Then ' Sf[^ŃeXg
                Directory.SetCurrentDirectory("..")
                AllTest.Check("tsutomu", "06A_VB", AddressOf Main, False)
                Exit Sub
            End If
            Dim l As LinkList = New LinkList()
            Dim loc, sumx, sumy, b0, b1 As Double
            If (Not ReadData(args(0), l, loc)) Then Return
            If (l.Count <= 2) Then Return
            C04A_VB.Calc(l, sumx, sumy, b0, b1)
            Dim dd(), d, e, d1, d2, r As Double
            For Each dd In l
                d = dd(1) - b0 - b1 * dd(0)
                d1 += d * d
                d = dd(0) - sumx
                d2 += d * d
            Next
            If (d2 = 0) Then d2 = 1
            d = loc - sumx
            d = Math.Sqrt((d1 / (l.Count - 2.0)) * (1 + 1.0 / l.Count + d * d / d2))
            e = b0 + b1 * loc
            Console.WriteLine("0 {0:F2}" + vbCrLf + "1 {1:F4}" + vbCrLf + "Est {2:F3}", b0, b1, e)
            Dim rr() As Double = {0.7, 0.9}
            For Each r In rr
                Dim g As Double = d * CalcRevT(0.5 + r / 2, l.Count - 2)
                Console.WriteLine("{0}% {1:F2} ` {2:F2}", CType(r * 100 + 0.5, Integer), e - g, e + g)
            Next
        End Sub
#End If
        Public Class Data
            Public EstimateLOC As Integer
            <XmlArrayAttribute("ArrayOfArrayOfDouble")> _
            Public list()() As Double
        End Class
        ''' t@Cf[^Ǎ݂܂B
        Public Shared Function ReadData(ByVal fnam As String, ByVal l As LinkList, ByRef loc As Double)
            Dim data As Data
            Try ' t@CJ
                Dim xr As XmlSerializer = New XmlSerializer(GetType(Data))
                Dim sr As StreamReader = New StreamReader(fnam)
                data = CType(xr.Deserialize(sr), Data)
                sr.Close()
            Catch e As FileNotFoundException
                Console.Error.WriteLine(e.Message)
                Return False
            End Try
            Dim d() As Double
            For Each d In data.list
                l.Add(d)
            Next
            loc = data.EstimateLOC
            Return True
        End Function
        Public Shared Function FuncT(ByVal x As Double, ByVal o As Object) As Double
            Dim n As Integer = CType(o, Integer)
            Return Math.Pow(1 + x * x / n, -(n + 1) / 2.0)
        End Function
        Public Shared Function GFunc(ByVal x As Double, ByVal n As Integer) As Double
            Return 0.5 + Math.Exp(lngamma((n + 1) / 2.0) - lngamma(n / 2.0)) / Math.Sqrt(n * Math.PI) _
                * C05A_VB.Simpson(AddressOf FuncT, 0, x, n)
        End Function
        Public Shared Function CalcRevT(ByVal x As Double, ByVal n As Integer) As Double
            Dim v, m, lo, up As Double
            up = 3
            Dim cnt As Integer
            While (GFunc(up, n) < x)
                up *= 2
            End While
            While (up - lo > 0.00000001 AndAlso ++cnt < 64)
                m = (up + lo) / 2
                v = GFunc(m, n)
                If (v < x) Then
                    lo = m
                Else
                    up = m
                End If
            End While
            Return m
        End Function
        ''' (x) = Math.Exp(lngamma(x))
        Public Shared Function lngamma(ByVal xx As Double) As Double
            Dim cof() As Double = {76.18009173, -86.50532033, 24.01409822, _
             -1.231739516, 0.00120858003, -0.00000536382}
            Dim x As Double = xx - 1.0
            Dim tmp As Double = x + 5.5
            tmp -= (x + 0.5) * Math.Log(tmp)
            Dim ser As Double = 1.0
            Dim j As Integer
            For j = 0 To 5
                x += 1.0
                ser += cof(j) / x
            Next
            Return -tmp + Math.Log(2.50662827465 * ser)
        End Function
    End Class
End Namespace
